mob = {}
activeMob = {}

mob.__index = mob

function mob:destroy()
	for i, mob in ipairs(activeMob) do
        if (mob == self) then
		table.remove(activeMob, i)
        end
    end
end



function mob:new(x,y,mobtype)
	local mobObj = {}
	
	-- exclamation
	alert   = love.graphics.newImage('image/MOB/alert.png')
	alert:setFilter( "nearest", "nearest" )
	
	
	-- bomber animation
	mobObj.walkright_bomber   = love.graphics.newImage('image/MOB/bomber_right.png')
	mobObj.walkright_bomber:setFilter( "nearest", "nearest" )
	mobObj.walkleft_bomber   = love.graphics.newImage('image/MOB/bomber_left.png')
	mobObj.walkleft_bomber:setFilter( "nearest", "nearest" )
	mobObj.dontwalkright_bomber   = love.graphics.newImage('image/MOB/bomber_right_nomove.png')
	mobObj.dontwalkright_bomber:setFilter( "nearest", "nearest" )
	mobObj.dontwalkleft_bomber   = love.graphics.newImage('image/MOB/bomber_left_nomove.png')
	mobObj.dontwalkleft_bomber:setFilter( "nearest", "nearest" )

	walking_right_bomber = newAnimation(mobObj.walkright_bomber, 6, 9, 0.10, 0)
	walking_left_bomber = newAnimation(mobObj.walkleft_bomber, 6, 9, 0.10, 0)
	dont_walking_right_bomber = newAnimation(mobObj.dontwalkright_bomber, 6, 9, 0.50, 0)
	dont_walking_left_bomber = newAnimation(mobObj.dontwalkleft_bomber, 6, 9, 0.50, 0)
	--
	

	mobObj.x = x
	mobObj.y = 412
	mobObj.width = 6
	mobObj.h = 9
	mobObj.type = mobtype
	mobObj.direction = "left"
	mobObj.walking = "false"
	mobObj.timer = 0
	mobObj.speed = 1
	mobObj.attackmode = "false"
	mobObj.dopatrol = "false"
	mobObj.alert = "false"
	mobObj.alertdraw = "false"
	mobObj.alerttimer = 0
	mobObj.detectleft = 400
	mobObj.detectright = 400
	mobObj.health = 100
	mobObj.gettingdamage = "false"
	mobObj.gettingdamagetimer = 0
	mobObj.colordamage = "false"
	mobObj.y_velocity = 0
	mobObj.rol = "left" -- knockback direction
	
	timerrandom = math.random(1,5)
	
	
	return setmetatable(mobObj, mob)
	
end

function mob:AI(dt)
-- Mob patrol
if self.dopatrol == "true" then
		self.timer = self.timer + dt
if self.timer >= 0 and self.timer <= 2 then
		self.walking = "true"
		self.direction = "left"
	end
if self.timer >= 2 and self.timer <= 4 then
		self.walking = "false"
		self.direction = "right"
	end
if self.timer >= 4 and self.timer <= 6 then
		self.walking = "true"
		self.direction = "right"
	end
if self.timer >= 6 and self.timer <= 8 then
		self.walking = "false"
		self.direction = "left"
	end
if self.timer >= 8 and self.timer <= 9 then
		self.timer = 0
	end
end

if self.type == "bomber" then

for i,player in ipairs(activePlayer) do

-- Knockback
if self.y_velocity ~= 0 then 
		self.y = self.y - self.y_velocity * dt
		self.y_velocity = self.y_velocity - gravity * dt
		if rol == "left" then
  		self.x = self.x + 100 * dt * player.knockback
		end
		if rol == "right" then
  		self.x = self.x - 100 * dt * player.knockback
		end
-- Mob position 		
if self.y > 412 then 
		self.y_velocity = 0
		self.y = 412
	end
end
-- Mob detect player
if self.alert == "true" then
		self.alerttimer = self.alerttimer + dt
if self.alerttimer >= 0 and self.alerttimer <= 1 then
		self.alertdraw = "true"
	else
		self.alertdraw = "false"
	end
end
-- Mob getting damage color
if self.gettingdamage == "true" then
		self.gettingdamagetimer = self.gettingdamagetimer + dt
if self.gettingdamagetimer >= 0 and self.gettingdamagetimer <= 1 then
		self.colordamage = "true"
	end
if self.gettingdamagetimer >= 1 and self.gettingdamagetimer <= 2 then
		self.colordamage = "false"
	end
end
-- Mob attacking player + mob getting damage by player
if self.x > player.x and self.x < player.x + 10 and self.alert == "true"  then
		player.health = player.health -1 
		camera.y = math.random(1,5)
	end
if self.x < player.x and self.x > player.x - 10 and self.alert == "true" then
	player.health = player.health -1 
	camera.y = math.random(1,5)
end
if self.x > player.x and self.x < player.x + 100 and player.attack == "true" and player.direction == "right" then
		self.health = self.health - player.damage * 5
		rol = "left"
if self.y_velocity == 0 then 
		self.y_velocity = jump_height
	end
elseif self.x < player.x and self.x > player.x - 100 and player.attack == "true" and player.direction == "left" then
		self.health = self.health - player.damage * 5
		rol = "right"
if self.y_velocity == 0 then 
		self.y_velocity = jump_height
	end
end

-- Mob death
if self.health <= 0 then
	self:destroy()
end

-- Detection player (vision range)
if self.direction == "right" then
	self.detectleft = 200
	self.detectright = 400
end
if self.direction == "left" then
	self.detectleft = 400
	self.detectright = 200
end
-- Follow player when alerted
if self.x > player.x and self.x < player.x + self.detectleft then
		self.walking = "true"
		self.direction = "left"
		self.dopatrol = "false"
		self.alert = "true"
		self.speed = 1
elseif self.x < player.x and self.x > player.x - self.detectright  then
		self.walking = "true"
		self.direction = "right"
		self.dopatrol = "false"
		self.alert = "true"
		self.speed = 1
else
		self.dopatrol = "true"
		self.alert = "false"
		self.speed = 1
		self.alerttimer = 0
	end
end
-- Movement + Animation update
if self.walking == "true" and self.direction == "left" then
	walking_left_bomber:update(dt)
	self.x = self.x - self.speed
end
if self.walking == "true" and self.direction == "right" then
	walking_right_bomber:update(dt)
	self.x = self.x + self.speed
end
if self.walking == "false" and self.direction == "right" then
	dont_walking_right_bomber:update(dt)
end
if self.walking == "false" and self.direction == "left" then
	dont_walking_left_bomber:update(dt)
end
end
end

function mob:draw()

if self.type == "bomber" then
-- Health bar mob
	love.graphics.setColor(255,40,40)
	love.graphics.rectangle("fill", self.x - 10, self.y + 120, self.health, 10 )
	love.graphics.setColor(255,255,255)
if self.alertdraw == "true" then
	love.graphics.draw(alert,self.x + 25,self.y - 70,0,12,12)
else end

-- Damage color
if self.colordamage == "true" then
	love.graphics.setColor(255,40,40)
end 
-- Animation draw
if self.walking == "true" and self.direction == "left" then
	walking_left_bomber:draw(self.x, self.y,0,12) 
end
if self.walking == "true" and self.direction == "right" then
	walking_right_bomber:draw(self.x, self.y,0,12) 
end
if self.walking == "false" and self.direction == "right" then
	dont_walking_right_bomber:draw(self.x, self.y,0,12) 
end
if self.walking == "false" and self.direction == "left" then
		dont_walking_left_bomber:draw(self.x, self.y,0,12) 
end
	love.graphics.setColor(255,255,255)

end
end


function UPDATE_MOB(dt)
for i, mob in ipairs(activeMob) do
    	mob:AI(dt)
	end
end

function DRAW_MOB()
	for i, mob in ipairs(activeMob) do
    	mob:draw()
	end
end
