player = {}
activePlayer = {}

player.__index = player

function player:destroy()
	for i, player in ipairs(activePlayer) do
        if (player == self) then
		table.remove(activePlayer, i)
        end
    end
end

function player:dead()
	for i, player in ipairs(activePlayer) do
        if (player == self) then
		table.remove(activePlayer, i)
        end
    end
end


function player:new(x,y)
	local playerObj = {}

	-- BASIC SKIN NO WEAPON
	playerObj.walkright   = love.graphics.newImage('image/SKIN/basic/basic_right.png')
	playerObj.walkright:setFilter( "nearest", "nearest" )
	playerObj.walkleft   = love.graphics.newImage('image/SKIN/basic/basic_left.png')
	playerObj.walkleft:setFilter( "nearest", "nearest" )
	playerObj.dontwalkright   = love.graphics.newImage('image/SKIN/basic/basic_nomove_right.png')
	playerObj.dontwalkright:setFilter( "nearest", "nearest" )
	playerObj.dontwalkleft   = love.graphics.newImage('image/SKIN/basic/basic_nomove_left.png')
	playerObj.dontwalkleft:setFilter( "nearest", "nearest" )
	-- ANIMATION
	walking_right = newAnimation(playerObj.walkright, 5, 10, 0.10, 0)
	walking_left = newAnimation(playerObj.walkleft, 5, 10, 0.10, 0)
	dont_walking_right = newAnimation(playerObj.dontwalkright, 5, 10, 0.50, 0)
	dont_walking_left = newAnimation(playerObj.dontwalkleft, 5, 10, 0.50, 0)
	
	-- BASIC SKIN WEAPON
	playerObj.walkrightweapon   = love.graphics.newImage('image/SKIN/basic/basic_right_weapon.png')
	playerObj.walkrightweapon:setFilter( "nearest", "nearest" )
	playerObj.walkleftweapon   = love.graphics.newImage('image/SKIN/basic/basic_left_weapon.png')
	playerObj.walkleftweapon:setFilter( "nearest", "nearest" )
	playerObj.dontwalkrightweapon   = love.graphics.newImage('image/SKIN/basic/basic_nomove_right_weapon.png')
	playerObj.dontwalkrightweapon:setFilter( "nearest", "nearest" )
	playerObj.dontwalkleftweapon   = love.graphics.newImage('image/SKIN/basic/basic_nomove_left_weapon.png')
	playerObj.dontwalkleftweapon:setFilter( "nearest", "nearest" )
	-- ANIMATION
	walking_right_weapon = newAnimation(playerObj.walkrightweapon, 5, 10, 0.10, 0)
	walking_left_weapon = newAnimation(playerObj.walkleftweapon, 5, 10, 0.10, 0)
	dont_walking_right_weapon = newAnimation(playerObj.dontwalkrightweapon, 5, 10, 0.50, 0)
	dont_walking_left_weapon = newAnimation(playerObj.dontwalkleftweapon, 5, 10, 0.50, 0)
	

	-- PLAYER POSITION
	playerObj.x = x
	playerObj.y = 400
	playerObj.width = 5 
	playerObj.h = 10 
	playerObj.y_velocity = 0
	
	-- PLAYER STATS
	playerObj.level = 0
	playerObj.health = 180
	playerObj.maxhealth = 180
	playerObj.energy = 180
	playerObj.maxenergy = 180
	playerObj.speed = 1
	playerObj.speedreset = 3
	playerObj.speedweapon = 2
	playerObj.direction = "left"
	playerObj.armed = "false"
	playerObj.skin = "basic"
	playerObj.moving = "false"
	playerObj.attack = "false"
	
	playerObj.damage = 1
	playerObj.damagebonus = 0
	playerObj.knockback = 5
	playerObj.knockbackbonus = 0
	
	playerObj.attacktimer = 0
	playerObj.charge = "false"
	playerObj.chargetimer = 0
	playerObj.attackcooldown = "false"
	playerObj.autoenergy = 0.1
	playerObj.chargepower = 30
	playerObj.chargepowerrester = 30
	playerObj.motioneffect = "false"
	playerObj.with = "false"
	playerObj.name = "Guest"
	
	return setmetatable(playerObj, player)
	
end

function player:AI(dt)
self.energy = self.energy + self.autoenergy

if self.skin == "basic" then
if self.armed == "false" then
self.speed = self.speedreset
if love.keyboard.isDown("right") then
walking_right:update(dt)
self.x = self.x + self.speed
self.direction = "right"
self.moving = "true"
elseif love.keyboard.isDown("left") then
walking_left:update(dt)
self.x = self.x - self.speed
self.direction = "left"
self.moving = "true"
else
self.moving = "false"
end

if self.moving == "false" and self.direction == "right" then
dont_walking_right:update(dt)
end
if self.moving == "false" and self.direction == "left" then
dont_walking_left:update(dt)
end
end
end

end

function player:draw()
-- BASIC SKIN DRAW
if self.skin == "basic" then
--NOT ARMED
if self.armed == "false" then
if self.moving == "true" then
if self.direction == "right" then
walking_right:draw(self.x, self.y,0,12) 
end
if self.direction == "left" then
walking_left:draw(self.x - 10, self.y,0,12) 
end
end
if self.moving == "false" then
if self.direction == "right" then
dont_walking_right:draw(self.x - 10, self.y,0,12) 
end
if self.direction == "left" then
dont_walking_left:draw(self.x - 10, self.y,0,12) 
end
end
end
-- ARMED


end
-- END BASIC SKIN



end

function player.keypressed(key)
for i,player in ipairs(activePlayer) do
end
end

function UPDATE_PLAYER(dt)
for i, player in ipairs(activePlayer) do
    	player:AI(dt)
	end
end

function DRAW_PLAYER()
	for i, player in ipairs(activePlayer) do
    	player:draw()
	end
end
